//----------------------------------------------------------
// Copyright (C) K-Group srl. All rights reserved.
//----------------------------------------------------------
// KNewsManagerStatic.js

// NOTA: DA RIFATTORIZZARE IN UNA CLASSE A PARTE, DA ISTANZIARE
// E DA UTILIZZARE POI IN TAL MODO (COME ISTANZA, NON COME
// BLOCCO DI CODICE GLOBALE)

var KNewsManagerStatic_Url = "";
var KNewsManagerStatic_AutoUpdateInterval = 120000; // TEMPO IN MILLISECONDI
var KNewsManagerStatic_AutoUpdateOkCallback = null;
var KNewsManagerStatic_AutoUpdateErrorCallback = null;
var KNewsManagerStatic_AutoUpdate = null;
var KNewsManagerStatic_TimerId = null;
var KNewsManagerStatic_CacheUriTrickEnabled = true;
var KNewsManagerStatic_LastErrorMessage = "";
var KNewsManagerStatic_NewsCollection = null;
var KNewsManagerStatic_MostRecentNewsDate = null;

// URI COMBINE SUPPORT FUNCTION
function KNewsManagerStatic_UriCombine(uri1, uri2) {
	var r1 = uri2;
	if (r1.length>0 && (r1.charAt(0)=='?' || r1.charAt(0)=='&')) {
		// RIMUOVO IL PRIMO CARATTERE
		r1 = r1.substring(1);
	}
	// CONCATENO LE DUE PARTI CON CARATTERE DI COLLEGAMENTO VARIABILE
	r1 = (uri1 + (uri1.indexOf('?')!=-1 ? '&' : '?') + r1);
	return(r1);
}

function KNewsManagerStatic_StartAutoUpdate(StartImmediately) {
   // CHECK PER PARAMETRO
   if (typeof StartImmediately == "undefined") {
      // PARAMETRO NON PASSATO --> LO DICHIARO ADESSO (DEFAULT A "true")
      StartImmediately = true;
   }
   
   // STOPPO IL TIMER PER SICUREZZA (IN CASO FOSSE GIA' IN ESECUZIONE)
   KNewsManagerStatic_StopAutoUpdate();
   
   // SE SPECIFICATO, FACCIO UNA PRIMA CHIAMATA (PER EVITARE CHE LA PRIMA
   // CHIAMATA AVVENGA DOPO L'INTERVALLO INVECE CHE SUBITO) ...
   if (StartImmediately) {
      KNewsManagerStatic_RetrieveData();
   }
   
   // ... E FACCIO RIPARTIRE IL TIMER
   KNewsManagerStatic_TimerId = window.setInterval(KNewsManagerStatic_RetrieveData, KNewsManagerStatic_AutoUpdateInterval);
}

function KNewsManagerStatic_StopAutoUpdate() {
   if (KNewsManagerStatic_TimerId != null) {
      // SE C'E' UN TIMER ATTIVO --> LO ELIMINO
      window.clearInterval(KNewsManagerStatic_TimerId);
   }
}

function KNewsManagerStatic_RetrieveData() {
   // ACQUISISCO L'URL
   var url = KNewsManagerStatic_Url;
   
   // SE E' SABILITATO IL TRICK PER LA CACHE DI IE, LO APPLICO
   if (KNewsManagerStatic_CacheUriTrickEnabled) {
      // NOTA : CUT = C.ACHE U.RI T.RICK
      url = KNewsManagerStatic_UriCombine(url, encodeURIComponent("CUTDummy=" + new Date().toString()));
   }
   
   // ISTANZIO LA WEB REQUEST
   var w1 =  new Sys.Net.WebRequest();
   
   // RIMPIAZZO PARAMETRI
   url = ReplaceUrl(url);
   
   // IMPOSTO I PARAMETRI
   w1.set_url(url);
   w1.set_httpVerb("GET");
   w1.add_completed(KNewsManagerStatic_OnRetrievingData);
   
   // INVOCO LA CHIAMTA
   w1.invoke();
}

// ON RETRIEVING DATA
function KNewsManagerStatic_OnRetrievingData(executor, eventArgs) {
   if (executor.get_responseAvailable()) {
      var resp;
      var ListNews;
      var UpdateLocally = true;
      
      // VALUTO I DATI ARRIVATI
      try {
				resp = executor.get_responseData()
//				resp = resp.replace(/\'/gi,/'/);
//				resp = resp.replace("/'","'");
//				resp = resp.replace(/\\\/gi,/\/);
//				resp = resp.replace("\\\","\\");
//				resp = resp.replace(/"/'"/gi,/"'"/);
				resp = resp.replace(/ \\'/,"'");
				resp = resp.replace(/\\'/,"'");
				resp = resp.replace(/\\\'/,"'");
				resp = resp.replace(/\'/,"'");
        resp = eval( "(" + resp + ")");
         
         // COSTRUISCO LA LISTA DELLE NEWS
         ListNews = new KNewsCollection(resp);
         
         // CONTROLLO SE LA NEWS PIU' RECENTE TRA QUELLE APPENA ARRIVATE
         // E' PIU' RECENTE DELLA PIU' RECENTE DI QUELLE ATTUALMENTE
         // PRESENTI
         if (KNewsManagerStatic_MostRecentNewsDate == null) {
            // PRIMA RICEZIONE DI NEWS
            if (ListNews.Items.length > 0) {
               // L'ELENCO DELLE NEWS RICEVUTE NE CONTIENE ALMENO UNA
               UpdateLocally = true;
            } else {
               // L'ELENCO DELLE NEWS RICEVUTE -NON- NE CONTIENE NEANCHE UNA
               UpdateLocally = false;
            }
         } else {
            // RICEZIONI SUCCESSIVE
            if (ListNews.Items.length > 0) {
               // L'ELENCO DELLE NEWS RICEVUTE NE CONTIENE ALMENO UNA
               if (KNewsManagerStatic_MostRecentNewsDate != ListNews.Items[0].PubDate.toString()) {
                  // LA NEWS LOCALE PIU' RECENTE E' DIVERSA DALLA NEWS REMOTA PIU' RECENTE --> AGGIORNO
                  UpdateLocally = true;
               } else {
                  // LA NEWS LOCALE PIU' RECENTE -NON- E' DIVERSA DALLA NEWS REMOTA PIU' RECENTE --> -NON- AGGIORNO
                  UpdateLocally = false;
               }
            } else {
               // L'ELENCO DELLE NEWS RICEVUTE -NON- NE CONTIENE NEANCHE
               // UNA (PROBABILMENTE C'E' STATO UN ERRORE DI RETE)
               UpdateLocally = false;
            }
         }
         
         // SE E' IL CASO DI AGGIORNARE LE NEWS LOCALI...
         if (UpdateLocally) {
            // ... LO FACCIO, SIMPLY =)
            KNewsManagerStatic_MostRecentNewsDate = ListNews.Items[0].PubDate.toString();
            // SWAPPO LA COLLECTION DELLE NEWS
            KNewsManagerStatic_NewsCollection = ListNews;
            // SE E' IMPOSTATO UNA CALLBACK --> LA ESEGUO
            if (KNewsManagerStatic_AutoUpdateOkCallback != null) {
               KNewsManagerStatic_AutoUpdateOkCallback();
            }
         }
      } catch(e1) {
         KNewsManagerStatic_LastErrorMessage = "Data unavailable";
         
         if (KNewsManagerStatic_AutoUpdateErrorCallback != null) {
            KNewsManagerStatic_AutoUpdateErrorCallback();
         }
      }
   } else {
      if (executor.get_timedOut()) {
         KNewsManagerStatic_LastErrorMessage = "Action timed out";
         
         if (KNewsManagerStatic_AutoUpdateErrorCallback != null) {
            KNewsManagerStatic_AutoUpdateErrorCallback();
         }
      } else {
         if (executor.get_aborted()) {
            KNewsManagerStatic_LastErrorMessage = "Action aborted";
            
            if (KNewsManagerStatic_AutoUpdateErrorCallback != null) {
               KNewsManagerStatic_AutoUpdateErrorCallback();
            }
         }
      }
   }
}