﻿//----------------------------------------------------------
// Copyright (C) K-Group srl. All rights reserved.
//----------------------------------------------------------
// KTemplatedObject.js

function KTemplatedObject(Source) {
   KObject.call(this, Source);
}

KTemplatedObject.prototype = new KObject();

KTemplatedObject.prototype.ReplaceInTemplate = function(TemplateSource, MappingSchema) {
   var tmp1;
   
   // IMPOSTO LA STRINGA TEMPORANEA SUL SOURCE DEL TEMPLATE
   tmp1 = TemplateSource;
   
   if ( (typeof MappingSchema == "undefined") || (MappingSchema == null) ) {
      // SCHEMA -NON- DEFINITO --> PROCESSO TUTTE LE PROPRIETA' DELL'ISTANZA
      // E SOSTITUISCO I PLACEHOLDER CON I RELATIVI VALORI
      for (var property in this) {
         if (typeof this[property] != 'function') {
            tmp1 = tmp1.replace(new RegExp("KPH_" + property, "gi"), this[property]);
         }
      }
   } else {
      // SCHEMA DEFINITO --> LO UTILIZZO PER SOSTITUIRE I PLACEHOLDER
      // CON I VALORI ATTUALI
      var ReplacingValue;
      var PlaceholderName;
      for (var i = 0; i < MappingSchema.length; i++) {
         // ACQUISISCO IL VALORE DELLA PROPRIETA' (O FUNZIONE) CORRENTE
         ReplacingValue = (typeof this[MappingSchema[i].elementName] == "function"? this[MappingSchema[i].elementName]() : this[MappingSchema[i].elementName]);
         // SE E' STATA SPECIFICATA UNA FUNZIONE DI MAPPING...
         if ( (typeof MappingSchema[i].mappingFunction == "function") && (MappingSchema[i].mappingFunction != null) ) {
            // ... LA APPLICO SUL DATO CORRENTEMENTE ACQUISITO
            ReplacingValue = MappingSchema[i].mappingFunction(ReplacingValue);
         }
         
         // CONTROLLO SE E' STATO SPECIFICATO IL NOME DEL PLACEHOLDER
         PlaceholderName = ( (typeof MappingSchema[i].placeholderName == "undefined") || (MappingSchema[i].placeholderName == null) ? MappingSchema[i].elementName : MappingSchema[i].placeholderName )
         
         // ESEGUO IL REPLACE DEL PLACEHOLDER COI VALORE ATTUALE
         tmp1 = tmp1.replace(new RegExp("KPH_" + PlaceholderName, "gi"), ReplacingValue);
      }
   }
   
   // RITORNO IL VALORE
   return tmp1;
}