﻿///------------------------------------------------------------------------------
/// <copyright company="The K-Group">
///			Copyright (c) - The K-Group.  All rights reserved.
///     Author:     Brago
///     History:    24-01-07 created
///
///     Description:
///				Funzioni inerenti la gestione dei settings
/// </copyright> 
///------------------------------------------------------------------------------

var GlobSelection;					// Variabile che stabilisce che tipo i filtro è stato scelto
var Livello;								// Variabile che stabilisce il livello attivo delle combo a cascata

/////// Dichiarazione variabili Settaggi ////////
var FTK_LG;// Lingua
var FTK_QT;// Quantità notizie
var FTK_ST;// Sito
var FTK_SE;// Sezione Sito
var FTK_TR;// Torneo
var FTK_TM;// Team
var FTK_PL;// Player

var NumeroNotizie;
////////////////////////////////////////////////////////////////////////////////
//
// Funzione iniziale
//
////////////////////////////////////////////////////////////////////////////////
function Init() {
	LoadAllSettings();
  System.Gadget.onSettingsClosing = SettingsClosing;
  InitUISetting();
}

////////////////////////////////////////////////////////////////////////////////
//
// Lettura di tutti i settings
//
////////////////////////////////////////////////////////////////////////////////
function LoadAllSettings() {
	//Lettura dati

	//////////////////////////////// Lingua
	if (System.Gadget.Settings.read("FTK_LG") != ""){
		FTK_LG = System.Gadget.Settings.read("FTK_LG");
	}else{
		//Eventuale Valore di Default
		FTK_LG = "it-IT";
	}		
	//////////////////////////////// Quantità notizie
	if (System.Gadget.Settings.read("FTK_QT") != ""){
		FTK_QT = System.Gadget.Settings.read("FTK_QT");
	}else{
		//Eventuale Valore di Default
		FTK_QT = "10";
	}
	//////////////////////////////// Sito
	if (System.Gadget.Settings.read("FTK_ST") != ""){
		FTK_ST = System.Gadget.Settings.read("FTK_ST");
	}else{
		//Eventuale Valore di Default
		FTK_ST = "1";
	}	
	
	//////////////////////////////// Sezione Sito
	if (System.Gadget.Settings.read("FTK_SE") != ""){
		FTK_SE = System.Gadget.Settings.read("FTK_SE");
	}else{
		//Eventuale Valore di Default
		FTK_SE = "";
	}		
	//////////////////////////////// Torneo
	if (System.Gadget.Settings.read("FTK_TR") != ""){
		FTK_TR = System.Gadget.Settings.read("FTK_TR");
	}else{
		//Eventuale Valore di Default
		FTK_TR = "";
	}
	//////////////////////////////// Team
	if (System.Gadget.Settings.read("FTK_TM") != ""){
		FTK_TM = System.Gadget.Settings.read("FTK_TM");
	}else{
		//Eventuale Valore di Default
		FTK_TM = "";
	}	
	//////////////////////////////// Player
	if (System.Gadget.Settings.read("FTK_PL") != ""){
		FTK_PL = System.Gadget.Settings.read("FTK_PL");
	}else{
		//Eventuale Valore di Default
		FTK_PL = "";
	}
}

////////////////////////////////////////////////////////////////////////////////
//
// Inizializzazione controlli settings con i valori memorizzati [working progress]
//
////////////////////////////////////////////////////////////////////////////////
function InitUISetting(){
	// Valorizzazione delle combo di selezione settaggio
	
	$get("FTK_LG").value = FTK_LG;
	$get("FTK_QT").value = FTK_QT;
	
	/*
	// non funziona... le combo sono dinamiche... 
	var lev2_00 = $get("lev2_00");
	var lev2_01 = $get("lev2_01");

	ElementShow(lev2_00);
	lev2_00.value = FTK_SE;
	ElementShow(lev2_01);
	lev2_01.value = FTK_TR;
	
	//$get("lev2_01").value = FTK_TR;
	$get("lev2_02").value = FTK_TM;
	$get("lev2_03").value = FTK_PL;
	*/
}

////////////////////////////////////////////////////////////////////////////////
//
// Scrittura di tutti i settings
//
////////////////////////////////////////////////////////////////////////////////
function WriteAllSettings() {
	// Recupero valori da Selezioni
	FTK_LG = $get("FTK_LG").value;
	FTK_QT = $get("FTK_QT").value;
	FTK_SE = $get("lev2_00").value;
	FTK_TR = $get("lev2_01").value;
	FTK_TM = $get("lev2_02").value;
	FTK_PL = $get("lev2_03").value;

	//Salvataggio dati nei settaggi
	System.Gadget.Settings.write("FTK_LG", FTK_LG)	//	Lingua
	System.Gadget.Settings.write("FTK_QT", FTK_QT)	//	Quantità Notizie
	System.Gadget.Settings.write("FTK_ST", FTK_ST)	//	Sito
	System.Gadget.Settings.write("FTK_SE", FTK_SE)	//	Sezione
	System.Gadget.Settings.write("FTK_TR", FTK_TR)	//	Torneo
	System.Gadget.Settings.write("FTK_TM", FTK_TM)	//	Team
	System.Gadget.Settings.write("FTK_PL", FTK_PL)	//	Player
	
	System.Gadget.Settings.write("RequestUrl", GetRequestUrl());
}

////////////////////////////////////////////////////////////////////////////////
//
// Impostazione url richiesto e controlli di validità richiesta
//
////////////////////////////////////////////////////////////////////////////////
function GetRequestUrl(){
	var _url = ArrRequestedUrl[0];
	_url = ArrRequestedUrl[GlobSelection];
	return _url;
}

////////////////////////////////////////////////////////////////////////////////
//
// salvataggio permanete di tutti i settings
//
////////////////////////////////////////////////////////////////////////////////
function SetSelection(controllo){
	var myOption;
	myOption = document.getElementById('NumeroNotizie');
	//myOption = document.getElementById(controllo);
	NumeroNotizie = myOption.value;
}


////////////////////////////////////////////////////////////////////////////////
//
// Evento chiusura delle finestra settings
//
////////////////////////////////////////////////////////////////////////////////
function SettingsClosing(event)
{
    if (event.closeAction == event.Action.commit)
    {
        CommitSaveSettings();
    }
}

////////////////////////////////////////////////////////////////////////////////
//
// legge settings persistenti
//
////////////////////////////////////////////////////////////////////////////////
function LoadSetting()
{
    if (System.Gadget.Settings.read("SettingsExist"))
    {

    }
}

////////////////////////////////////////////////////////////////////////////////
//
// salvataggio impostazioni settings persistenti
//
////////////////////////////////////////////////////////////////////////////////
function SaveSetting()
{
    System.Gadget.Settings.write("SettingsExist", true);
}

////////////////////////////////////////////////////////////////////////////////
//
// save clock settings
//
////////////////////////////////////////////////////////////////////////////////
function CommitSaveSettings()
{
	WriteAllSettings();
}

////////////////////////////////////////////////////////////////////////////////
//
// Rimpiazzo dell'url con i valori delle variabili
//
////////////////////////////////////////////////////////////////////////////////
function ReplaceUrl(_myUrl)
{
	_myUrl = _myUrl.replace(/FTK_LG/gi,FTK_LG.toString());
	_myUrl = _myUrl.replace(/FTK_QT/gi,FTK_QT.toString());
	_myUrl = _myUrl.replace(/FTK_ST/gi,FTK_ST.toString());
	_myUrl = _myUrl.replace(/FTK_SE/gi,FTK_SE.toString());
	_myUrl = _myUrl.replace(/FTK_TR/gi,FTK_TR.toString());
	_myUrl = _myUrl.replace(/FTK_TM/gi,FTK_TM.toString());
	_myUrl = _myUrl.replace(/FTK_PL/gi,FTK_PL.toString());
	return _myUrl;
}

////////////////////////////////////////////////////////////////////////////////
//
// Richiesta asincrona (per le opzioni)
//
////////////////////////////////////////////////////////////////////////////////
	function SendRequestForSettings(CallBack, _url)
	{
		var data = null;// i dati della richiesta sono nulli perchè lavoriamo solo sul body della richiesta
		
		// visualizzo elemento d'attesa
		//ElementShow($get("loading"));
		
		_url = ReplaceUrl(_url);
   
    // Instantiate the WebRequest object.
    var wRequest =  new Sys.Net.WebRequest();
    
    //----------
    
    // Set the request Url.  
    wRequest.set_url(_url);
    
    // Set the request verb.
    wRequest.set_httpVerb("GET");
          
    // Set user's context
    //wRequest.set_userContext("user's context");
            
    // Set the request handler.
    wRequest.add_completed(CallBack);
    
    // Execute the request.
    wRequest.invoke();
    
    //wRequest.add_completed(pippo);
	}
		
////////////////////////////////////////////////////////////////////////////////
//
// Funzione azioni dopo ricezione risposta richiesta asincrona
//
////////////////////////////////////////////////////////////////////////////////		
	function Charge(executor, eventArgs) 
	{
    if(executor.get_responseAvailable()){
			var resp;
			var _out = Combo;
			var tmp = "";

			Array.clear(Combo);
			resp = eval( "(" + executor.get_responseData() + ")");

			for (var i = 0; i < resp.length; i++) {
				
        var option = document.createElement("option");
        if (i == 0){ 
          option.text = "  ----  ";
					option.value = 0;
					Combo.add(option);
        }
        option = document.createElement("option");
        option.text = resp[i].Descrizione;
        option.value = resp[i].Id;
        try {
							Combo.add(option);
				} catch (e) {
							Combo.add(option, null);
				}
				// nasconde elemento d'attesa
				//ElementHide($get("loading"));
			}
		}else{
			if (executor.get_timedOut())
			{
					//alert("Timed Out");
			}
			else{
				if (executor.get_aborted())
				{
								//alert("Aborted");
				}
			}
		}
	}
	
////////////////////////////////////////////////////////////////////////////////
//
// Disattiva tutti i controlli che non sono necesari
//
////////////////////////////////////////////////////////////////////////////////	
function DisableUnusedControls(){
	for (var i = 0; i < 4; i++) {
		Combo = $get("lev2_0" + i);
		Combo.disabled=true;

		ElementHide(Combo);
		for (var y = 0; y < Combo.length; y++) {
		Combo.remove(y);
		}
	}
}
////////////////////////////////////////////////////////////////////////////////
//
// Azioni Scelta livello 1
//
////////////////////////////////////////////////////////////////////////////////	
function SelectLev1(selezione) {
		//controllo quale selezione è stata scelta e visualizzo i controlli corretti
		GlobSelection = selezione;
		Livello = 0;
		
		
		DisableUnusedControls();

		switch (GlobSelection)
		{
			case 0:
				Array.clear(ArrCombo);
				Array.add(ArrCombo,"lev2_01");	//[0] competizione
				Array.add(ArrCombo,"lev2_02");	//[1] squadra
				Array.add(ArrCombo,"lev2_03");	//[2] Calciatore
				Combo = $get(ArrCombo[Livello]);
				Combo.disabled = true;
				ElementShow(Combo);
				SendRequestForSettings(Charge, ArrServices[1]);
				Combo.disabled = false;
				break;
			case 1:
				Array.clear(ArrCombo);
				Array.add(ArrCombo,"lev2_01");  //[0] competizione
				Array.add(ArrCombo,"lev2_02");	//[1] squadra
				Combo = $get(ArrCombo[Livello]);
				Combo.disabled = true;
				ElementShow(Combo);
				SendRequestForSettings(Charge, ArrServices[1]);
				Combo.disabled = false;
				break;
			case 2:
				Array.clear(ArrCombo);
				Array.add(ArrCombo,"lev2_00");	//[0] Sezione
				Combo = $get(ArrCombo[Livello]);
				Combo.disabled = true;
				ElementShow(Combo);
				SendRequestForSettings(Charge, ArrServices[0]);
				Combo.disabled = false;
				break;
			case 3:
				break;
			case 4:
//		 inserire nascondi select non utilizzate
				break;
			default:
		}	
}

////////////////////////////////////////////////////////////////////////////////
//
// Azioni Scelta livelli maggiori all'1
//
////////////////////////////////////////////////////////////////////////////////	
function SelectLev2() {
		//controllo quale selezione è stata scelta e visualizzo i controlli corretti
		var Parametro;
		if (Livello == 0) {
			Livello = 1;
		}else if(Livello == 1){
			Livello = 2;
		}else if(Livello == 2){
			Livello = 3;
		}
		
		
	if (Livello == 1){
//		DisableUnusedControls();
			switch (GlobSelection)
			{
				case 0:
					Combo = $get(ArrCombo[Livello - 1]);
					Paramentro = Combo.value;
					Combo.disabled = true;
					Combo = $get(ArrCombo[Livello]);
					ElementShow(Combo);
					SendRequestForSettings(Charge, ArrServices[2] + Paramentro);
					Combo.disabled = false;
					break;
				case 1:
					Combo = $get(ArrCombo[Livello - 1]);
					Paramentro = Combo.value;
					Combo.disabled = true;
					Combo = $get(ArrCombo[Livello]);
					ElementShow(Combo);
					SendRequestForSettings(Charge, ArrServices[2] + Paramentro);
					Combo.disabled = false;
					break;
			}	
	}else if(Livello == 2){
			switch (GlobSelection)
			{
				case 0:
					Combo = $get(ArrCombo[Livello - 1]);
					Paramentro = Combo.value;
					Combo.disabled = true;
					Combo = $get(ArrCombo[Livello]);
					ElementShow(Combo);
					SendRequestForSettings(Charge, ArrServices[3] + Paramentro);
					Combo.disabled = false;
					break;
			}
	}
}

function pre_PopolaOpzioni(){

	Array.forEach(ArrCombo, PopolaOpzioni)
	
//	if (Array.contains(ArrComboLev2,arrayElement))
}

function PopolaOpzioni(arrayElement, index, array){
//	Array.contains(_ArrComboLev2,)
	if (Array.indexOf(ArrCombo, array[index]) != -1){
		Combo = $get(array[index]);
		SendRequestForSettings(Charge, ArrServices[0]);
//	x.innerHTML += "Array in posizione " + array[index] + " : !!!<br>";
	x.innerHTML += "Array in posizione " + Array.indexOf(ArrCombo, array[index]) + " : !!! " +  array[index] + " <br>";
	}
}


		function AllElementHide()
		{

		}
		
		function AllElementHide()
		{

		}

		function ElementHide(element)
		{
//			$get(element).style.display='none';
				element.style.display='none';
		}
		
		function ElementShow(element)
		{
//			$get(element).style.display='';
				element.style.display='';
		}
