﻿// CONSTANTS
var GadgetVersion_Current = "1.0.0.0";
var Kidget_SiteId = 14;
var GadgetVersion_CheckUrl = "http://feed.kidget.it/v1/versions/Check.aspx?st=" + Kidget_SiteId.toString() + "&v=" + GadgetVersion_Current;
var GadgetVersion_OnMandatoryUpdate = null;
var GadgetVersion_OnOptionalUpdate = null;
var GadgetVersion_OnAlreadyUpdated = null;

// INIT
function Init()
	{
		System.Gadget.onUndock = function(){ undockedState(); };
		System.Gadget.onDock = function(){ dockedState(); };
		System.Gadget.Flyout.file = "flyout.html";
		System.Gadget.settingsUI = "Settings.html";
	}

// CHECK STATE
function checkState() {
   if (System.Gadget.docked) { 
      dockedState();
   } else {
      undockedState();
   }
}

// UNDOCKED STATE
function undockedState() {
   location.replace("undocked.html");
   //location.replace("flyout.html");
}

// DOCKED STATE
function dockedState() {
   location.replace("docked.html");
   //location.replace("flyout.html");
}

// SHOW FLYOUT
function ShowFlyout(NewsIndex) {
   if (typeof NewsIndex != "undefined") {
      System.Gadget.Settings.write("Flyout_CurrentNewsIndex", NewsIndex);
   }
   
   // TODO : da testare questo "doppio switch"
   System.Gadget.Flyout.show = false;
   System.Gadget.Flyout.show = true;
}

// HIDE FLYOUT
function HideFlyout() {
   System.Gadget.Flyout.show = false;
}

//// GENERIC ERROR
//function GenericError(msg) {
//   $get('MatchesContainer').innerHTML = 'Attenzione, errore generico di rete.' + (typeof msg != "undefined" ? '\n\nDETTAGLIO:' + msg : '');
//}

// ############################################################################
// #                                                                          #
// #                                  AUDIO                                   #
// #                                                                          #

function get_AudioEnabled() {
   if (System.Gadget.Settings.read("AudioEnabled").toString() == "") {
      // SETTING NON PRESENTE --> DI DEFAULT "true"
      return true;
   } else {
      return System.Gadget.Settings.read("AudioEnabled");
   }
}

function set_AudioEnabled(Enabled) {
   if (typeof Enabled == "undefined") {
      Enabled = true;
   }
   System.Gadget.Settings.write("AudioEnabled", Enabled);
}

function set_AudioAutoSwitch() {
   set_AudioEnabled(!get_AudioEnabled());
}

function AudioButtonController_Update(el1) {
   if (get_AudioEnabled()) {
      el1.className = "AudioOn";
   } else {
      el1.className = "AudioOff";
   }
}

// #                                                                          #
// #                                  AUDIO                                   #
// #                                                                          #
// ############################################################################


// ############################################################################
// #                                                                          #
// #                                VERSIONING                                #
// #                                                                          #

function GadgetVersion_CheckForUpdate() {
   var w1 =  new Sys.Net.WebRequest();
   
   // IMPOSTO I PARAMETRI
   w1.set_url(GadgetVersion_CheckUrl);
   w1.add_completed(GadgetVersion_OnCheckingCallback);
   
   // INVOCO LA CHIAMTA
   w1.invoke();
}

function GadgetVersion_OnCheckingCallback(executor, eventArgs) {
   if (executor.get_responseAvailable()) {
      var resp;
      var LatestVersion = null;
      
      // VALUTO I DATI ARRIVATI
      try {
//				resp = resp.replace(/\\\'/gi,/\'/);
        resp = eval( "(" + executor.get_responseData() + ")");
         
         // COSTRUISCO L'OGGETO DELL'ULTIMA VERSIONE
         LatestVersion = resp;
         
         // CONTROLLO PER UPDATE OBBLIGATORIO
         if (LatestVersion.Mandatory == true) {
            // NUOVO UPDATE OBBLIGATORIO
            if (GadgetVersion_OnMandatoryUpdate != null) {
               GadgetVersion_OnMandatoryUpdate(LatestVersion);
            }
         } else {
            // -O- NESSUN UPDATE -O- UPDATE NON OBBLIGATORIO
            if (LatestVersion.Version > GadgetVersion_Current) {
               // UPDATE -NON- OBBLIGATORIO
               if (GadgetVersion_OnOptionalUpdate != null) {
                  GadgetVersion_OnOptionalUpdate(LatestVersion);
               }
            } else {
               // NESSUN UPDATE
               if (GadgetVersion_OnAlreadyUpdated != null) {
                  GadgetVersion_OnAlreadyUpdated(LatestVersion);
               }
            }
         }
      } catch(e1) {
         // ERRORE GENERICO
         if (GadgetVersion_OnAlreadyUpdated != null) {
            GadgetVersion_OnAlreadyUpdated(LatestVersion);
         }
      }
   } else {
      // ERRORE GENERICO (ACTION TIMED OUT O ACTION ABORTED)
      if (GadgetVersion_OnAlreadyUpdated != null) {
         GadgetVersion_OnAlreadyUpdated(LatestVersion);
      }
   }
}

// #                                                                          #
// #                                VERSIONING                                #
// #                                                                          #
// ############################################################################