//----------------------------------------------------------
// Copyright (C) K-Group srl. All rights reserved.
//----------------------------------------------------------
// KObject.js

// CTOR
function KObject(Source) {
   if (typeof Source != 'undefined') {
      this.fromJSON(Source);
   }
}

// PARSE JSON
KObject.prototype.fromJSON = function(Source) {
   for (var property in Source) {
      this[property] = Source[property];
   }
}

// DEFAULT PROPERTY FILTER
KObject.prototype.defaultPropertyFilter = function(property) {
   return (typeof property != 'function');
}

// TO JSON
KObject.prototype.toJSON = function(propertyFilter) {
   var tmp1 = [];
   var v1;
   
   if (typeof propertyFilter == 'undefined') {
      // SE NON E' STATO IMPOSTATO UN FILTRO SU QUALI PROPRIETA' SERIALIZZARE --> USO IL FILTRO DI DEFAULT
      propertyFilter = this.defaultPropertyFilter;
   }
   
   var i = 0;
   for (var property in this) {
      if (propertyFilter(this[property])) {
         v1 = this[property];
         tmp1[i] = property + ' : ' + (typeof v1 == 'string'?'\'' + v1 + '\'':(v1.toJSON?v1.toJSON():v1.toString()));
         i++;
      }
   }
   
   return '{' + tmp1.join(',') + '}';
}

KObject.prototype.toString = function() {
   var tmp1 = '';
   
   for (var property in this) {
      tmp1 += property + ': ' + this[property] + '\n';
   }
   
   return tmp1;
}